#pragma once

#include "Renderer.h"
#include <streams.h>
#include <dvdmedia.h>
#include <Poco/format.h>
#include <Poco/Logger.h>
#include <Poco/Mutex.h>
#include <queue>

using std::queue;


struct __declspec(uuid("{71771540-2017-11cf-ae26-0020afd79767}")) CLSID_DSVideoRenderer;


class DSVideoRenderer: public CBaseVideoRenderer {
private:
	Poco::Logger& _log;

	Poco::FastMutex _lock;

	Renderer& _renderer;

	bool _supportYUV2;
	D3DFORMAT _format;

	long _w;
	long _h;
	LPDIRECT3DTEXTURE9 _texture;

	DWORD _current;
	PerformanceTimer _readTimer;
	DWORD _readTime;


	/** eNX` */
	void releaseTexture();

	/** MediaTypȅ擾 */
	bool getMediaTypeName(const CMediaType* pmt, string& type, D3DFORMAT* format);

	/** YUY2RGBϊ */
	void convertYUY2_RGB(LPBYTE dst, LPBYTE src, size_t len);

public:
	DSVideoRenderer(Renderer& renderer, bool supportYUV2, LPUNKNOWN unk, HRESULT* result);
	virtual ~DSVideoRenderer();

	HRESULT CheckMediaType(const CMediaType* pmt);
	HRESULT SetMediaType(const CMediaType* pmt);
	HRESULT DoRenderSample(IMediaSample* sample);

	LPDIRECT3DTEXTURE9 getTexture();

	DWORD currentTime();

	DWORD readTime();

	/**  */
	long width();

	/**  */
	long height();

	/** AXyNg */
	float getDisplayAspectRatio();

	/** ` */
	void draw(const int x, const int y, int w = -1, int h = -1, int aspectMode = 0, int flipMode = 0, DWORD col = 0xffffffff, int tx = 0, int ty = 0, int tw = -1, int th = -1);
};

typedef DSVideoRenderer* DSVideoRendererPtr;